<?php
namespace TYPO3\CMS\K20events\Hooks;


use TYPO3\CMS\Backend\Utility\BackendUtility;



/**
 * This hook extends the tcemain class.
 * It catches changes on tx_k20events_event
 *
 * @author Karsten Klinker Madsen
 */
class TceMainProcessdatamap {


    public static function processDatamap_afterDatabaseOperations($status, $table, $id, &$fieldArray, &$tcemain) {


        if ($table == 'tx_k20events_event' && count ($fieldArray) > 1) {
            $event = BackendUtility::getRecord ($table, $status == 'new' ? $tcemain->substNEWwithIDs [$id] : $id);
            $rows = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows ('*', 'tx_k20events_date', 'eventid = '.$event['uid'],'', 'start_date ASC', '1', $uidIndexField= '');
            $first_date = $rows[0];

            if($event['freq'] != 'none' || $event['freqid'] > 0){
                $dayInSeconds = 86400;
                $requrrences = array();
                switch ($event['freq']) {
                    case "none":
                        //IF freq == none "From active to Inactive";
                        //  remove freqid
                        // NOTE: This disables only this record, To disable all a delete i necessary
                        //$GLOBALS['TYPO3_DB']->sql_query('UPDATE tx_k20events_event SET freqid = 0 WHERE uid = '.$event['uid']);
                        self::deleteRequrrences($event);
                        break;
                    case "day":
                        if($event['repeat_end_type'] == 0){ //After n times
                            for ($x = 1; $x < $event['repeat_end_times']; $x++) {
                                $requrrences[] = $x * $event['every'] * $dayInSeconds;
                            }
                        }else{ //by date
                            $add = $event['every'] * $dayInSeconds;
                            $x = $first_date['start_date'];
                            $i = 1;
                            while ($x <= $event['repeat_end_date']) {
                                $x = $i * $add + $first_date['start_date'];
                                $requrrences[] = $i * $add;
                                $i++;
                            }
                        }
                        break;
                    case "week":
                        $requrrences = self::findWeekRequrrences($event,$first_date);

                        break;
                    case "month":
                        $requrrences = self::findMonthRequrrences($event,$first_date);
                        break;
                    case "year":
                        $requrrences = self::findYearRequrrences($event,$first_date);
                        break;
                }
                if($event['freq'] != 'none'){
                    self::deleteRequrrences($event);
                    self::addRequrrences($event,$requrrences,$first_date);
                }
            }
        }
    }



    public static function findYearRequrrences($event,$first_date){

        $requrrences = array();

        if($event['repeat_end_type'] < '1' || $event['repeat_end_date'] < '1'){
            $event['repeat_end_date'] = $first_date['start_date'] + (86400 * 365 * $event['repeat_end_times'] * $event['every']);
        }

        $start = new \DateTime(date('Y-m-d',$first_date['start_date']));
        $end = new \DateTime(date('Y-m-d',$event['repeat_end_date']+86400));
        $interval = new \DateInterval('P'.$event['every'].'Y');
        $period = new \DatePeriod($start, $interval, $end);


        $yearInterval = $event['every'];

        $fakeYear = 0;
        $currentYear = $start->format('n');

        foreach ($period as $date) {
            //--------$monthInterval must be first-------------------
            if ($date->format('n') !== $currentYear) {
                $currentYear = $date->format('Y');
                $fakeYear++;
            }
            if ($fakeYear % $yearInterval !== 0) {
                continue;
            }
            $secToNextRequrrence = $date->format('U') - $first_date['start_date'];
            if($secToNextRequrrence != '0'){
                $requrrences[] = $secToNextRequrrence;
            }


            //STOP WHEN REPEAT TIMES IS REACHED----------------------
            if(count($requrrences) == $event['repeat_end_times'] && $event['repeat_end_type'] != '1'){
                break;
            }
            //STOP WHEN REPEAT TIMES IS REACHED----------------------
            //STOP WHEN REPEAT DATE IS REACHED----------------------
            // $end and $event['repeat_end_date'] will do that for us
            //STOP WHEN REPEAT DATE IS REACHED----------------------
        }
        return $requrrences;

    }















    public static function findMonthRequrrences($event,$first_date){

        $requrrences = array();

        if($event['repeat_end_type'] < '1' || $event['repeat_end_date'] < '1'){
            $event['repeat_end_date'] = $first_date['start_date'] + (86400 * 365 * $event['repeat_end_times']);
        }

        $start = new \DateTime(date('Y-m-d',$first_date['start_date']));
        $end = new \DateTime(date('Y-m-d',$event['repeat_end_date']+86400));
        $interval = new \DateInterval('P1D');
        $period = new \DatePeriod($start, $interval, $end);

        // only trigger every Interval months...
        $monthInterval = $event['every'];

        // initialize fake week
        $newMonth = 0;
        $fakeMonth = 0;
        $currentMonth = $start->format('n');

        foreach ($period as $date) {
            //--------$monthInterval must be first-------------------
            if ($date->format('n') !== $currentMonth) {
                $currentMonth = $date->format('n');
                $fakeMonth++;
                $newMonth = 1;
            }
            if ($fakeMonth % $monthInterval !== 0) {
                continue;
            }

            //nth day in month
            if($event['repeat_by'] == 0){
                $startday = date('j',$first_date['start_date']);
                $loopday = $date->format('j');
                if($startday == $loopday){
                    $secToNextRequrrence = $date->format('U') - $first_date['start_date'];
                    //$secToNextRequrrence = $date->format('Y-m-d');//TEST
                    if($secToNextRequrrence != '0'){
                        $requrrences[] = $secToNextRequrrence;
                    }
                }
            }
            else{//first selected weekday in month
                $startweekday = date('N',$first_date['start_date']);
                $loopweekday = $date->format('N');
                if($startweekday == $loopweekday && $newMonth == 1){
                    $secToNextRequrrence = $date->format('U') - $first_date['start_date'];
                    //$secToNextRequrrence = $date->format('Y-m-d');//TEST
                    if($secToNextRequrrence != '0'){
                        $requrrences[] = $secToNextRequrrence;
                        $newMonth = 0;
                    }
                }
            }




            //STOP WHEN REPEAT TIMES IS REACHED----------------------
            if(count($requrrences) == $event['repeat_end_times'] && $event['repeat_end_type'] != '1'){
                break;
            }
            //STOP WHEN REPEAT TIMES IS REACHED----------------------
            //STOP WHEN REPEAT DATE IS REACHED----------------------
            // $end and $event['repeat_end_date'] will do that for us
            //STOP WHEN REPEAT DATE IS REACHED----------------------

        }
        return $requrrences;

    }







































    public static function findWeekRequrrences($event,$first_date){

        $requrrences = array();


        if($event['repeat_end_type'] < '1' || $event['repeat_end_date'] < '1'){
            $event['repeat_end_date'] = $first_date['start_date'] + (86400 * 365 * $event['repeat_end_times']);
        }

        $start = new \DateTime(date('Y-m-d',$first_date['start_date']));
        $end = new \DateTime(date('Y-m-d',$event['repeat_end_date']+86400));
        $interval = new \DateInterval('P1D');
        $period = new \DatePeriod($start, $interval, $end);

    // only trigger every Interval weeks...
        $weekInterval = $event['every'];

    // initialize fake week
        $fakeWeek = 0;
        $currentWeek = $start->format('W');

        foreach ($period as $date) {
            //--------$weekInterval must be first-------------------
            if ($date->format('W') !== $currentWeek) {
                $currentWeek = $date->format('W');
                $fakeWeek++;
            }
            if ($fakeWeek % $weekInterval !== 0) {
                continue;
            }
            //--------$weekInterval must be first-------------------

            $dayOfWeek = $date->format('N');
            if($event['every_weekday_'.$dayOfWeek] == '1'){
                //Dont add current day
                $secToNextRequrrence = $date->format('U') - $first_date['start_date'];
                if($secToNextRequrrence != '0'){
                    $requrrences[] = $secToNextRequrrence;
                }
            }

            //STOP WHEN REPEAT TIMES IS REACHED----------------------
            if(count($requrrences) == $event['repeat_end_times'] && $event['repeat_end_type'] != '1'){
                break;
            }
            //STOP WHEN REPEAT TIMES IS REACHED----------------------
            //STOP WHEN REPEAT DATE IS REACHED----------------------
            // $end and $event['repeat_end_date'] will do that for us
            //STOP WHEN REPEAT DATE IS REACHED----------------------
        }

        return $requrrences;

    }













    public static function addRequrrences($event,$requrrences,$first_date){
        $limit = 500;
        $i=1;
        foreach ($requrrences as $value){
            $newdate = $first_date;
            $newdate['start_date'] = $first_date['start_date'] + $value;
            $newdate['end_date'] = $first_date['end_date'] + $value;
            unset($newdate['uid']);
            $query = $GLOBALS['TYPO3_DB']->INSERTquery('tx_k20events_date', $newdate, $no_quote_fields=false);
            $GLOBALS['TYPO3_DB']->sql_query($query);
            $i++;
            if($i == $limit){
                break;
            }
        }
    }
    public static function deleteRequrrences($event){
        $rows = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('uid', 'tx_k20events_date', 'eventid = '.$event['uid'], $groupBy = '', 'start_date ASC', $limit = '', $uidIndexField = '');
        $first = true;
        foreach ($rows as $key => $value){
            if($first == false){
                $uid .= $value['uid'].',';
            }
            $first = false;
        }

        $uids = substr($uid,0,-1);

        // DONT USE DATAHANDLER, IT ENDS IN A LOOP
        //$GLOBALS['TYPO3_DB']->sql_query('UPDATE tx_k20events_event SET deleted = 1 WHERE uid IN ('.$uids.')');
        if($uids != ''){
            //file_put_contents('/Volumes/Disk2/Sites/ASINO/udvikling/dblog.txt', $uids, FILE_APPEND | LOCK_EX);
            //file_put_contents('/Volumes/Disk2/Sites/ASINO/udvikling/dblog.txt', $uids);
            $GLOBALS['TYPO3_DB']->sql_query('DELETE FROM tx_k20events_date WHERE uid IN ('.$uids.')');
        }
    }
}

?>
