<?php
return [
    'ctrl' => [
        'requestUpdate' => 'freq,repeat_end_type,allday',
        'title' => 'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:ctrl.tx_k20events_event.title',
        'label' => 'header',
        'tstamp' => 'tstamp',
        'crdate' => 'crdate',
        'cruser_id' => 'cruser_id',
        'delete' => 'deleted',
        'enablecolumns' => [
            'disabled' => 'hidden',
            'starttime' => 'starttime',
            'endtime' => 'endtime'
        ],
        'default_sortby' => 'tstamp DESC',
        'typeicon_classes' => [
            'default' => 'actions-edit-pick-date'
        ]
    ],
    'interface' => [
        'showRecordFieldList' => 'hidden,header,content,starttime,endtime'
    ],
    'columns' => [
        'dates' => [
            'label' => 'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.dates',
            'exclude' => 1,
            'config' => [
                'type' => 'inline',
                'foreign_table' => 'tx_k20events_date',
                'foreign_field' => 'eventid',
                'foreign_label' => 'start_date',
                'minitems' => '1',
                'appearance' => [
                    'collapseAll' => 1,
                    'expandSingle' => 1,
                ]
            ]
        ],
        'hidden' => [
            'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.disable',
            'exclude' => 1,
            'config' => [
                'type' => 'check',
                'default' => '0'
            ]
        ],
        'starttime' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.starttime',
            'config' => [
                'type' => 'input',
                'size' => '13',
                'eval' => 'datetime',
                'default' => '0'
            ]
        ],
        'endtime' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.endtime',
            'config' => [
                'type' => 'input',
                'size' => '13',
                'eval' => 'datetime',
                'default' => '0'
            ]
        ],
        'shortcut' => [
            'label' => 'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.shortcut',
            'config' => [
                'type' => 'group',
                'internal_type' => 'db',
                'allowed' => 'pages',
                'size' => '1',
                'maxitems' => '1',
                'minitems' => '0',
                'show_thumbs' => '1',
                'wizards' => [
                    'suggest' => [
                        'type' => 'suggest',
                        'default' => [
                            'additionalSearchFields' => 'nav_title, alias, url'
                        ]
                    ]
                ],
                'default' => 0
            ]
        ],
        'header' => [
            'label' => 'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.header',
            'config' => [
                'type' => 'input',
                'size' => '30',
                'max' => '255',
            ]
        ],
        'content' => [
            'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.text',
            'config' => [
                'type' => 'text',
                'cols' => '48',
                'rows' => '5',
                'wizards' => [
                    'RTE' => [
                        'notNewRecords' => 1,
                        'RTEonly' => 1,
                        'type' => 'script',
                        'title' => 'LLL:EXT:frontend/Resources/Private/Language/locallang_ttc.xlf:bodytext.W.RTE',
                        'icon' => 'actions-wizard-rte',
                        'module' => [
                            'name' => 'wizard_rte'
                        ]
                    ]
                ]
            ],
            'defaultExtras' => 'richtext:rte_transform[mode=ts_css]',
        ],
        'image' => [
            'label' => 'LLL:EXT:lang/locallang_general.xlf:LGL.images',
            'config' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::getFileFieldTCAConfig('image', [
                'appearance' => [
                    'createNewRelationLinkTitle' => 'LLL:EXT:frontend/Resources/Private/Language/locallang_ttc.xlf:images.addFileReference'
                ],
                // custom configuration for displaying fields in the overlay/reference table
                // to use the imageoverlayPalette instead of the basicoverlayPalette
                'foreign_types' => [
                    '0' => [
                        'showitem' => '
							--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
							--palette--;;filePalette'
                    ],
                    \TYPO3\CMS\Core\Resource\File::FILETYPE_TEXT => [
                        'showitem' => '
							--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
							--palette--;;filePalette'
                    ],
                    \TYPO3\CMS\Core\Resource\File::FILETYPE_IMAGE => [
                        'showitem' => '
							--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
							--palette--;;filePalette'
                    ],
                    \TYPO3\CMS\Core\Resource\File::FILETYPE_AUDIO => [
                        'showitem' => '
							--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.audioOverlayPalette;audioOverlayPalette,
							--palette--;;filePalette'
                    ],
                    \TYPO3\CMS\Core\Resource\File::FILETYPE_VIDEO => [
                        'showitem' => '
							--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.videoOverlayPalette;videoOverlayPalette,
							--palette--;;filePalette'
                    ],
                    \TYPO3\CMS\Core\Resource\File::FILETYPE_APPLICATION => [
                        'showitem' => '
							--palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
							--palette--;;filePalette'
                    ]
                ]
            ], $GLOBALS['TYPO3_CONF_VARS']['GFX']['imagefile_ext'])
        ],
        'allday' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.allday',
            'config' => [
                'type' => 'check',
                'default' => 0
            ]
        ],
        'start_time' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.start_time',
            'displayCond' => 'FIELD:allday:!=:1',
            'config' => [
                'type' => 'input',
                'size' => '12',
                'max' => '20',
                'eval' => 'time',
                'default' => '0'
            ]
        ],
        'end_time' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.end_time',
            'displayCond' => 'FIELD:allday:!=:1',
            'config' => [
                'type' => 'input',
                'size' => '12',
                'max' => '20',
                'eval' => 'time',
                'default' => '0'
            ]
        ],
        'freq' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.freq',
            'config' => [
                'renderType' => 'selectSingle',
                'type' => 'select',
                'size' => '1',
                'items' => [
                    [
                        'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.freq_none',
                        'none'
                    ],
                    [
                        'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.freq_day',
                        'day'
                    ],
                    [
                        'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.freq_week',
                        'week'
                    ],
                    [
                        'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.freq_month',
                        'month'
                    ],
                    [
                        'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.freq_year',
                        'year'
                    ]
                ]
            ]
        ],
        'every' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.every',
            'displayCond' => 'FIELD:freq:IN:day,week,month,year',
            'config' => [
                'type' => 'input',
                'size' => '4',
                'eval' => 'num',
                'default' => '1'
            ]
        ],
        'every_weekday_1' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.every_weekday_1',
            'displayCond' => 'FIELD:freq:IN:week',
            'config' => [
                'type' => 'check',
                'default' => '0'
            ]
        ],
        'every_weekday_2' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.every_weekday_2',
            'displayCond' => 'FIELD:freq:IN:week',
            'config' => [
                'type' => 'check',
                'default' => '0'
            ]
        ],
        'every_weekday_3' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.every_weekday_3',
            'displayCond' => 'FIELD:freq:IN:week',
            'config' => [
                'type' => 'check',
                'default' => '0'
            ]
        ],
        'every_weekday_4' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.every_weekday_4',
            'displayCond' => 'FIELD:freq:IN:week',
            'config' => [
                'type' => 'check',
                'default' => '0'
            ]
        ],
        'every_weekday_5' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.every_weekday_5',
            'displayCond' => 'FIELD:freq:IN:week',
            'config' => [
                'type' => 'check',
                'default' => '0'
            ]
        ],
        'every_weekday_6' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.every_weekday_6',
            'displayCond' => 'FIELD:freq:IN:week',
            'config' => [
                'type' => 'check',
                'default' => '0'
            ]
        ],
        'every_weekday_7' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.every_weekday_7',
            'displayCond' => 'FIELD:freq:IN:week',
            'config' => [
                'type' => 'check',
                'default' => '0'
            ]
        ],
        'repeat_by' => [
            'label' => 'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.repeat_by',
            'displayCond' => 'FIELD:freq:IN:month',
            'exclude' => 1,
            'config' => [
                'type' => 'radio',
                'items' => [
                    [
                        'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.repeat_by_0',
                        0
                    ],
                    [
                        'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.repeat_by_1',
                        1
                    ]
                ],
                'default' => '0'
            ]
        ],
        'repeat_end_type' => [
            'label' => 'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.repeat_end_type',
            'displayCond' => 'FIELD:freq:IN:day,week,month,year',
            'exclude' => 1,
            'config' => [
                'type' => 'radio',
                'items' => [
                    [
                        'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.repeat_end_type_0',
                        0
                    ],
                    [
                        'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.repeat_end_type_1',
                        1
                    ]
                ],
                'default' => '0'
            ]
        ],
        'repeat_end_times' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.repeat_end_times',
            'displayCond' => [
                'AND' => [
                    'FIELD:freq:IN:day,week,month,year',
                    'FIELD:repeat_end_type:IN:0'
                ]
            ],
            'config' => [
                'type' => 'input',
                'size' => '4',
                'eval' => 'num',
                'default' => '10'
            ]
        ],
        'repeat_end_date' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:columns.repeat_end_date',
            'displayCond' => [
                'AND' => [
                    'FIELD:freq:IN:day,week,month,year',
                    'FIELD:repeat_end_type:IN:1'
                ]
            ],
            'config' => [
                'type' => 'input',
                'size' => '12',
                'max' => '25',
                'eval' => 'date',
            ]
        ],
    ],
    'types' => [
        '1' => [
            'showitem' => '
             --div--;LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:div.dates, --palette--;LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:palette.time;time, dates,
             --div--;LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:div.content, header, image, content, shortcut,
             --div--;LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:div.recurrence, freqid, freq, every, --palette--;LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:palette.every_weekday;every_weekday,repeat_by, --palette--;LLL:EXT:k20events/Resources/Private/Language/locallang_db.xlf:palette.repeat_end;repeat_end,
             --div--;LLL:EXT:lang/locallang_tca.xlf:sys_news.tabs.access, hidden, starttime, endtime',
        ],
    ],
    'palettes' => [
        'time' => [
            'showitem' => 'allday,start_time,end_time',
            'canNotCollapse' => 1
        ],
        'every_weekday' => [
            'showitem' => 'every_weekday_1, every_weekday_2, every_weekday_3, every_weekday_4, every_weekday_5, every_weekday_6, every_weekday_7',
            'canNotCollapse' => 1
        ],
        'repeat_end' => [
            'showitem' => 'repeat_end_type,repeat_end_times,repeat_end_date',
            'canNotCollapse' => 1
        ],
    ]
];
